/// <reference types="react" />
import { History } from 'history';
import * as PropTypes from 'prop-types';
import * as React from 'react';
import { RouteConfig } from 'react-router-config';
import { Store } from 'redux';
export interface ConnectedRouterProps {
    children?: React.ReactNode;
    history: History;
    routes?: RouteConfig[];
    static?: boolean;
}
export declare class ConnectedRouter extends React.Component<ConnectedRouterProps> {
    static contextTypes: {
        store: PropTypes.Requireable<any>;
    };
    context: {
        store: Store<any>;
    };
    private unsubscribeFromHistory;
    constructor(props: ConnectedRouterProps);
    componentWillMount(): void;
    componentWillUnmount(): void;
    render(): React.ReactNode;
    private handleLocationChange(location);
    private findMatch(location);
}
