"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var PropTypes = require("prop-types");
var React = require("react");
var react_router_1 = require("react-router");
var react_router_config_1 = require("react-router-config");
var actions_1 = require("./actions");
var ConnectedRouter = /** @class */ (function (_super) {
    __extends(ConnectedRouter, _super);
    function ConnectedRouter(props) {
        var _this = _super.call(this, props) || this;
        _this.handleLocationChange = _this.handleLocationChange.bind(_this);
        return _this;
    }
    ConnectedRouter.prototype.componentWillMount = function () {
        var history = this.props.history;
        if (!this.props.static) {
            this.unsubscribeFromHistory = history.listen(this.handleLocationChange);
        }
        this.handleLocationChange(history.location);
    };
    ConnectedRouter.prototype.componentWillUnmount = function () {
        if (this.unsubscribeFromHistory) {
            this.unsubscribeFromHistory();
        }
    };
    ConnectedRouter.prototype.render = function () {
        var _a = this.props, children = _a.children, history = _a.history;
        return React.createElement(react_router_1.Router, { history: history }, children);
    };
    ConnectedRouter.prototype.handleLocationChange = function (location) {
        var match = this.findMatch(location);
        this.context.store.dispatch(actions_1.locationChange(location, match));
    };
    // tslint:disable-next-line no-any
    ConnectedRouter.prototype.findMatch = function (location) {
        if (!this.props.routes) {
            return undefined;
        }
        var matchedRoutes = react_router_config_1.matchRoutes(this.props.routes, location.pathname);
        var matchedRoute = matchedRoutes.find(function (route) { return route.match.isExact; });
        return matchedRoute && matchedRoute.match;
    };
    ConnectedRouter.contextTypes = { store: PropTypes.object };
    return ConnectedRouter;
}(React.Component));
exports.ConnectedRouter = ConnectedRouter;
