"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var history_1 = require("history");
function normalizeLocation(_a) {
    var _b = _a.pathname, pathname = _b === void 0 ? '/' : _b, _c = _a.search, search = _c === void 0 ? '' : _c, _d = _a.hash, hash = _d === void 0 ? '' : _d;
    return {
        pathname: pathname,
        search: search === '?' ? '' : search,
        hash: hash === '#' ? '' : hash,
    };
}
function addLeadingSlash(pathname) {
    return pathname.charAt(0) === '/' ? pathname : '/' + pathname;
}
function addBasename(basename, location) {
    if (!basename) {
        return location;
    }
    return __assign({}, location, { pathname: addLeadingSlash(basename) + location.pathname });
}
function stripBasename(basename, location) {
    if (!basename) {
        return location;
    }
    var base = addLeadingSlash(basename);
    if (location.pathname.indexOf(base) !== 0) {
        return location;
    }
    return __assign({}, location, { pathname: location.pathname.substr(base.length) });
}
function createNormalizedLocation(location) {
    return typeof location === 'string'
        ? history_1.parsePath(location)
        : history_1.createLocation(normalizeLocation(location));
}
function createURL(location) {
    return typeof location === 'string' ? location : history_1.createPath(location);
}
function noop() { } // tslint:disable-line no-empty
function createStaticHistory(_a) {
    var initialLocation = _a.location, _b = _a.basename, basename = _b === void 0 ? '' : _b, _c = _a.context, context = _c === void 0 ? {} : _c;
    var createHref = function (location) {
        return addLeadingSlash(basename + createURL(location));
    };
    var handleNewLocation = function (location, action) {
        context.action = action;
        context.location = addBasename(basename, createNormalizedLocation(location));
        context.url = createURL(context.location);
    };
    var handlePush = function (location) {
        handleNewLocation(location, 'PUSH');
    };
    var handleReplace = function (location) {
        handleNewLocation(location, 'REPLACE');
    };
    return {
        createHref: createHref,
        action: 'POP',
        location: stripBasename(basename, createNormalizedLocation(initialLocation)),
        push: handlePush,
        replace: handleReplace,
        go: noop,
        goBack: noop,
        goForward: noop,
        listen: function () { return noop; },
        block: function () { return noop; },
        length: 1,
    };
}
exports.createStaticHistory = createStaticHistory;
